<?php
/**
 * @package Daily_Game
 * @author dailygame.org
 * @version 1.4.5
 */
/*
Plugin Name: Daily Game
Plugin URI: http://www.playedonline.com/daily_game
Description: The plugin posts a new flash game for your readers every day.
Author: Played Online
Version: 1.4.5
Author URI: http://playedonline.com/
*/


/* Plugin implementation */
function get_data($xml_source, $tag)
{
    $pattern = "/".$tag."\>(.*?)\</";
    preg_match($pattern, $xml_source, $matches);
    return $matches[1];
}

function generate_message ($sXML, $adsense_code, $show_description, $show_instructions)
{
    // Resize the game
    $orig_height = $sXML["height"];
    $orig_width = $sXML["width"];
    $wrapper_height = $sXML["height"]; 

    if ((int)$sXML["width"] > 450)
    {
        $sXML["height"] = (string)round((int)$sXML["height"] / (int)$sXML["width"] * 450);
        $sXML["width"] = 450;
    }

    if ((int)$sXML["height"] <330)
    {
        $wrapper_height = 330;
    }

    $gotd_message = '<link rel="stylesheet" type="text/css" href="http://playedonline.com/javascripts/shadowbox/shadowbox.css"><script type="text/javascript" src="http://playedonline.com/javascripts/shadowbox/shadowbox.js"></script><script type="text/javascript">Shadowbox.init({modal:true});</script>';

    $gotd_message = $gotd_message.'<a href="'.$sXML["swf_url"].'" rel="shadowbox;height='.$orig_height.';width='.$orig_width.'"><img src="http://playedonline.com'.$sXML["thumb_url"].'" style="float:left; margin:10px;"></a>';
    $gotd_message = $gotd_message.'<div style="padding-top:5px;"><a href="'.$sXML["swf_url"].'" rel="shadowbox;height='.$orig_height.';width='.$orig_width.'">Play</a><br/>'.$sXML["description"].'<br/><!--more Read more--></div>';    
    $gotd_message = $gotd_message.'<div id="GameWrapper" style="clear:both;width:'.$sXML["width"].'px; height:'.$wrapper_height.'px; position:relative; margin:10px auto;">';

    if ($adsense_code != '')
    {
        $gotd_message = $gotd_message.'
          <script type="text/javascript">function hidePreRoll() {clearTimeout(prerolltimer);document.getElementById("GameEmbed").style.visibility = "visible";document.getElementById("PreRollAd").style.visibility = "hidden";} prerolltimer = window.setTimeout(hidePreRoll, 15000);</script>

          <div id="PreRollAd" style="position:absolute;top:0px;left:0px;right:0px;bottom:0px;">
            <div class="AdContent" style="text-align:center;fond-weight:bold; width:300px;margin:25px auto;">
              The game is loading'.$adsense_code.'Advertisement - click to <a href="#" onclick="hidePreRoll(); return false;">skip</a>
            </div>
          </div>

           <div id="GameEmbed" style="position:absolute;top:0px;left:0px;right:0px;bottom:0px;visibility:hidden;">
                <object width="'.$sXML["width"].'" height="'.$sXML["height"].'" base="." codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000">
                  <param name="movie" value="'.$sXML["swf_url"].'"/>
                  <param name="base" value="."/>
                  <param name="quality" value="high"/>
                  <param value="always" name="AllowScriptAccess"/>
                  <param value="exactfit" name="scale"/>
                  <embed width="'.$sXML["width"].'" height="'.$sXML["height"].'" src="'.$sXML["swf_url"].'" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" quality="high" allowscriptaccess="always"/>
                </object>
            </div>';
    }
    else
    {
        $gotd_message = $gotd_message.'
            <div id="GameEmbed" style="position:absolute;top:0px;left:0px;right:0px;bottom:0px;">
                <object width="'.$sXML["width"].'" height="'.$sXML["height"].'" base="." codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000">
                  <param name="movie" value="'.$sXML["swf_url"].'"/>
                  <param name="base" value="."/>
                  <param name="quality" value="high"/>
                  <param value="always" name="AllowScriptAccess"/>
                  <param value="exactfit" name="scale"/>
                  <embed width="'.$sXML["width"].'" height="'.$sXML["height"].'" src="'.$sXML["swf_url"].'" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" quality="high" allowscriptaccess="always"/>
                </object>
            </div>';
    }

    $gotd_message = $gotd_message.'</div>';

    if ($show_instructions and $sXML["instructions"] != '') {$gotd_message = $gotd_message."<br/><b>Instructions:</b><br/>".$sXML["instructions"];}
    
    /*if (get_option('daily_game_links_denied') == 'on')
        $gotd_message = $gotd_message.'<br/><br/><div style="text-align:center; font-size:smaller;">'.$sXML["game_name"].' is powered by playedonline.com</div>';
    else*/
        $gotd_message = $gotd_message.'<br/><br/><div style="text-align:center; font-size:smaller;"><a href="'.$sXML["game_url"].'" style="text-decoration:none;">'.$sXML["daily_game_name"].'</a> is '.urldecode($sXML["links"]).'</div>';


    return $gotd_message;
}

if ($_GET["getVersion"])
{
    echo "2";
    return;
}

if ($_POST["game_data"] != "" and $_POST["shared_key"] != "")
{    
    require_once('../../../wp-config.php');

    $sXML = array();
    $str = $_POST["game_data"];
    $sXML["game_name"] = get_data($str, "game_name");
    $sXML["daily_game_name"] = get_data($str, "daily_game_name");    
    $sXML["swf_url"] = get_data($str, "swf_url");
    $sXML["thumb_url"] = get_data($str, "thumb_url");    
    $sXML["width"] = get_data($str, "width");
    $sXML["height"] = get_data($str, "height");
    $sXML["description"] = get_data($str, "description");
    $sXML["instructions"] = get_data($str, "instructions");
    $sXML["category_name"] = get_data($str, "category_name");
    $sXML["game_url"] = get_data($str, "game_url");
    $sXML["links"] = get_data($str, "links");
    $secretKey = $_POST["shared_key"];

    if ($sXML["game_name"] == "")
    {
        echo "Mailformed XML";
    }
    else if (get_option('daily_game_enabled') == 0)
    {
        echo "Plugin Disabled";
    }
    else if (get_option('daily_game_'.date('l')) != 'on')
    {
        echo "Plugin configured to not post today";
    }
    else if ($secretKey != get_option('daily_game_shared_key'))
    {
        echo "Wrong secret key";
    }
    else
    {
        echo "Request Accepted.";

        $quick['action']="post";
        $quick['post_status']="publish";
        $quick['advanced_view'] = 1;
        if (get_option('qp_comments_enabled') == "t") {
            $quick['comment_status'] ="open";
        } else {
            $quick['comment_status'] ="closed";
        }
        $quick['pingback'] = 1;
        $quick['ping_status'] = "open";
        $quick['post_category'] = array((int)get_option('daily_game_category'));
        $quick['tags_input'] = 0;
        $quick['parent_id'] = 0;
        $quick['post_author'] = get_option('daily_game_author');
        $quick['menu_order'] = 0;
        $quick['post_content'] = generate_message ($sXML, get_option('daily_game_adsense_code'), true, true);
        $quick['post_content_filtered'] = $quick['post_content'];

        if (get_option('daily_game_title_template') == '')
            $quick['post_title'] = "Daily game ". date('M d') ." : ".$sXML["game_name"];
        else
        {
            $find = array("[GAME NAME]", "[DATE]", "[CATEGORY_NAME]");
            $replace = array($sXML["game_name"], date('M d'), $sXML["category_name"]);

            $quick['post_title'] = str_replace($find, $replace, get_option('daily_game_title_template'));
        }       

        $quick['prev_status'] = "publish";
        $quick['publish'] = "Publish";        
        $quick['referredby'] = "daily_game";

        remove_filter('content_save_pre', 'wp_filter_post_kses');
        $post_ID = wp_insert_post($quick);
        add_filter('content_save_pre', 'wp_filter_post_kses');

        if ($post_ID > 0)
            echo "Done"; 
        else
            echo "Error occured";
    }
}
else
{
    /* Admin code */
    // create custom plugin settings menu
    add_action('admin_menu', 'daily_game_create_menu');

    function daily_game_create_menu()
    {
        //create new settings sub menu
        add_options_page('Daily Game Plugin Settings', 'Daily Game', 'administrator', __FILE__, 'daily_game_settings_page', plugins_url('/images/icon.png', __FILE__));
        add_action( 'admin_init', 'register_mysettings' );
    }

    function register_mysettings()
    {
        //register our settings
        register_setting( 'daily-game-settings-group', 'daily_game_enabled' );
        register_setting( 'daily-game-settings-group', 'daily_game_links_denied' );
        register_setting( 'daily-game-settings-group', 'daily_game_shared_key' );
        register_setting( 'daily-game-settings-group', 'daily_game_title_template' );
        register_setting( 'daily-game-settings-group', 'daily_game_author' );        
        register_setting( 'daily-game-settings-group', 'daily_game_category' );
        register_setting( 'daily-game-settings-group', 'daily_game_adsense_code' );
        register_setting( 'daily-game-settings-group', 'daily_game_monday' );
        register_setting( 'daily-game-settings-group', 'daily_game_tuesday' );
        register_setting( 'daily-game-settings-group', 'daily_game_wednesday' );
        register_setting( 'daily-game-settings-group', 'daily_game_thursday' );
        register_setting( 'daily-game-settings-group', 'daily_game_friday' );
        register_setting( 'daily-game-settings-group', 'daily_game_saturday' );
        register_setting( 'daily-game-settings-group', 'daily_game_sunday' );
    }

    function daily_game_settings_page()
    { ?>
    <div class="wrap">
    <h2>Daily Game Options</h2>

    <form method="post" action="options.php">
      <?php settings_fields( 'daily-game-settings-group' ); ?>
      <table class="form-table">
          <tr valign="top">
          <th scope="row">Plugin Enabled</th>
          <td>
            <input type=radio name="daily_game_enabled" value="1" <?php echo (get_option('daily_game_enabled') == 1 ? "checked" : ""); ?> >Yes &nbsp;
            <input type=radio name="daily_game_enabled" value="0" <?php echo (get_option('daily_game_enabled') == 0 ? "checked" : ""); ?> >No
          </td>
          </tr>

          <tr valign="top">
          <th scope="row">Shared Key</th>
          <td>
            <input type="text" name="daily_game_shared_key" size=40 value="<?php echo get_option('daily_game_shared_key'); ?>" />
            <br/>
            <span style="font:smaller">This key is meant to protect you from abuse. Please <a href="http://playedonline.com/register_blog">register</a> to get a shared key.</span>
          </td>
          </tr>

          <tr valign="top">
          <th scope="row">Title</th>
          <td>
            <input type="text" name="daily_game_title_template" size=40 value="<?php echo get_option('daily_game_title_template'); ?>" />
            <br/>
            <span style="font:smaller">The title of the daily games posts. Leave blank to use the default title - "Daily game [DATE] : [GAME NAME]". <br/>[DATE], [GAME NAME] and [CATEGORY_NAME] will be replaced with the respective values.</span>
          </td>
          </tr>

          <tr valign="top">
          <th scope="row">Author ID</th>
          <td>
            <input type="text" name="daily_game_author" size=40 value="<?php echo get_option('daily_game_author'); ?>" />
            <br/>
            <span style="font:smaller">The ID of the user that will own the posts.</span>
          </td>
          </tr>

          <tr valign="top">
          <th scope="row">Category</th>
          <td>
            <select name="daily_game_category" />
            <?php
            $category_ids = get_all_category_ids();
            $selected_cat_id = get_option('daily_game_category');
            foreach($category_ids as $cat_id)
            {
              $cat_name = get_cat_name($cat_id);
              $selected = $cat_id == $selected_cat_id ? "selected" : "";
              echo '<option value="'.$cat_id.'" '.$selected.'>'.$cat_name;
            }
            ?>
            </select>
          </td>
          </tr>

          <tr valign="top">
          <th scope="row">Preroll Advert Code</th>
          <td>
            <textarea rows=7 cols=60 name="daily_game_adsense_code"><?php echo get_option('daily_game_adsense_code'); ?></textarea>
            <br/>
            <span style="font:smaller">Enter ad code (adsense or similar) to show a preroll before the game begins</span>
          </tr>

          <!--tr valign="top">
          <th scope="row">Disallow "Powered By" links</th>
          <td>
            <input type="checkbox" name="daily_game_links_denied" <?php echo (get_option('daily_game_links_denied') == 'on' ? "checked" : ""); ?> />                        
          </tr-->

          <tr valign="top">
          <th scope="row">Post games on</th>
          <td>
            <input type="checkbox" name="daily_game_monday" <?php echo (get_option('daily_game_monday') == 'on' ? "checked" : ""); ?> /> Monday &nbsp;
            <input type="checkbox" name="daily_game_tuesday" <?php echo (get_option('daily_game_tuesday') == 'on' ? "checked" : ""); ?> /> Tuesday &nbsp;
            <input type="checkbox" name="daily_game_wednesday" <?php echo (get_option('daily_game_wednesday') == 'on' ? "checked" : ""); ?> /> Wednesday &nbsp;
            <input type="checkbox" name="daily_game_thursday" <?php echo (get_option('daily_game_thursday') == 'on' ? "checked" : ""); ?> /> Thursday &nbsp;
            <input type="checkbox" name="daily_game_friday" <?php echo (get_option('daily_game_friday') == 'on' ? "checked" : ""); ?> /> Friday &nbsp;
            <input type="checkbox" name="daily_game_saturday" <?php echo (get_option('daily_game_saturday') == 'on' ? "checked" : ""); ?> /> Saturday &nbsp;
            <input type="checkbox" name="daily_game_sunday" <?php echo (get_option('daily_game_sunday') == 'on' ? "checked" : ""); ?> /> Sunday
            <br/>
            <span style="font:smaller">Choose the days to publish a game post</span>
          </td>
          </tr>
      </table>

      <p class="submit">
      <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
      </p>

    </form>
    </div>
    <?php }
}
?>
